import java.math.MathContext

class Fraction {
    int numerator;
    int denominator;

    Fraction(int numerator, int denominator) {
        this.numerator = numerator
        this.denominator = denominator
    }

    def asType(Class target) {
        switch (target) {
            case BigDecimal.class:
                return new BigDecimal(numerator).divide(
                        new BigDecimal(denominator), MathContext.DECIMAL32)
            case String.class:
                return numerator + "/" + denominator
            case Double.class:
                return Double.valueOf((double) numerator / (double) denominator)
            default:throw new RuntimeException("not supported: "+target);
        }
    }
}


def f = new Fraction(3, 11);

def bd = f as BigDecimal
println bd

def d = f as Double
println d

def s = f as String
println s